module calculo


! objetivo: calcular as propriedades


use varia


contains


      subroutine calculo_propri ()


      if(n > 1) then
        dt = (tf - ti)/(n - 1)
      else
        dt = 0.0d0
      end if

      do p = 1, n

	t(p) = ti + (p-1)*dt

        if(t(p) >= 1.0d+3) then
	  j=1
	else
	  j=2
	end if

	  
        do i=1,7

	  cp(i,p) = (a(i,1,j) + a(i,2,j)*t(p) + a(i,3,j)*(t(p)**2)  &
	          +  a(i,4,j)*(t(p)**3) + a(i,5,j)*(t(p)**4)) * ru / mm(i)

	  h(i,p) = (a(i,1,j)*t(p) + a(i,2,j)*(t(p)**2)/2.0d0  &
		 +  a(i,3,j)*(t(p)**3)/3.0d0 + a(i,4,j)*(t(p)**4)/4.0d0  & 
                 +  a(i,5,j)*(t(p)**5)/5.0d0 + a(i,6,j)) * ru / mm(i)
          if(i == 7 .and. t(p) > 600.0d0) h(i,p) = 0.0d0

	  s(i,p) = (a(i,1,j)*dlog(t(p)) + a(i,2,j)*t(p)  &
		 +  a(i,3,j)*(t(p)**2)/2.0d0 + a(i,4,j)*(t(p)**3)/3.0d0  & 
                 +  a(i,5,j)*(t(p)**4)/4.0d0 + a(i,7,j)) * ru / mm(i)

          g(i,p) = h(i,p) - t(p)*s(i,p)

        end do


	do i = 1,6

          gama(i,p) = cp(i,p) / (cp(i,p) - ru/mm(i))

	  k(i,p) = dexp((c(i,1,j)*dlog(t(p)) + c(i,2,j)/t(p)   &
		 +  c(i,3,j)/(t(p)**2) + c(i,4,j))) * 1.0d-4

	  mi(i,p) = dexp((b(i,1,j)*dlog(t(p)) + b(i,2,j)/t(p)   &
		  +  b(i,3,j)/(t(p)**2) + b(i,4,j))) * 1.0d-7

	end do

      end do


      end subroutine calculo_propri


end module calculo