module escreve


! objetivo: gerar arquivos de sada das propriedades calculadas


use varia


contains


      subroutine escreverot ()

      open(19,file='saida1.dat',form='formatted')
      write(19,10) n,ti,tf
   10 format(//,15x,'DADOS',//,   &
              6x,i6,' = Nmero de pontos a calcular',//,   &
            1pe12.4,' = Temperatura do incio da faixa (K)',//,   &
            1pe12.4,' = Temperatura do final da faixa  (K)',////,  &
                10x,'FAIXAS DE VALIDADE',//, &
                12x,'cp, h, s, g e gama: 200 a 6000 K',/, &
                12x,'exceto para a gua: 273 a 600 K.',//, &
                12x,'mi e k: 300 a 5000 K')

      write(19,30) ru
   30 format(//,1pe13.5,' = Constante universal dos gases (J/kmol.K)')

      write(19,31) 
   31 format(///,20x,'MASSA MOLECULAR (kg/kmol)',//, &
        t3,'H2O',t16,'O2',t29,'H2',t42,'H',t55,'O',t68,'OH')
      write(19,41) (mm(i),i=1,6)
   41 format(6(1pe13.5))

      write(19,32) 
   32 format(///,20x,'CONSTANTE DO GS (J/kg.K)',//, &
        t3,'H2O',t16,'O2',t29,'H2',t42,'H',t55,'O',t68,'OH')
      write(19,41) (ru/mm(i),i=1,6)

      write(19,33) 
   33 format(///,20x,'ENTALPIA DE FORMAO (J/kg)',//, &
        t3,'H2O',t16,'O2',t29,'H2',t42,'H',t55,'O',t68,'OH',t81,'H2O(l)')
      write(19,12) (hform(i),i=1,7)

      write(19,21)
   21 format(///,20x,'ENTALPIA (J/kg)',//, &
        t3,'T (K)',t16,'H2O',t29,'O2',t42,'H2',t55,'H',t68,'O',t81,'OH',t94,'H2O(l)')
      open(20,file='saida2.dat',form='formatted')
      do p=1,n
        write(19,11) t(p),(h(i,p),i=1,7)
        write(20,12) t(p),(1.0d-6*(h(i,p)-hform(i))*mm(i),i=1,6)
      end do
   11 format(8(1pe13.5))
      close(20)

      write(19,22)
   22 format(///,20x,'ENTROPIA (J/kg.K)',//, &
        t3,'T (K)',t16,'H2O',t29,'O2',t42,'H2',t55,'H',t68,'O',t81,'OH',t94,'H2O(l)')
      open(20,file='saida3.dat',form='formatted')
      do p=1,n
        write(19,11) t(p),(s(i,p),i=1,7)
        write(20,12) t(p),(1.0d-3*s(i,p)*mm(i),i=1,6)
      end do
      close(20)

      write(19,23)
   23 format(///,20x,'ENERGIA LIVRE DE GIBBS (J/kg)',//, &
        t3,'T (K)',t16,'H2O',t29,'O2',t42,'H2',t55,'H',t68,'O',t81,'OH',t94,'H2O(l)')
      open(20,file='saida4.dat',form='formatted')
      do p=1,n
        write(19,11) t(p),(g(i,p),i=1,7)
        write(20,12) t(p),(1.0d-6*g(i,p)*mm(i),i=1,6)
      end do
      close(20)

      write(19,24)
   24 format(///,20x,'CALOR ESPECFICO  PRESSO CONSTANTE (J/kg.K)',//, &
        t3,'T (K)',t16,'H2O',t29,'O2',t42,'H2',t55,'H',t68,'O',t81,'OH',t94,'H2O(l)')
      open(20,file='saida5.dat',form='formatted')
      do p=1,n
        write(19,11) t(p),(cp(i,p),i=1,7)
        write(20,12) t(p),(1.0d-3*cp(i,p)*mm(i),i=1,6)
      end do
      close(20)

      write(19,25)
   25 format(///,20x,'RAZO ENTRE OS CALORES ESPECFICOS (adimensional)',//, &
        t3,'T (K)',t16,'H2O',t29,'O2',t42,'H2',t55,'H',t68,'O',t81,'OH')
      open(20,file='saida6.dat',form='formatted')
      do p=1,n
        write(19,12) t(p),(gama(i,p),i=1,6)
        write(20,12) t(p),(gama(i,p),i=1,6)
      end do
   12 format(7(1pe13.5))
      close(20)

      write(19,26)
   26 format(///,20x,'VISCOSIDADE ABSOLUTA (Pa.s)',//, &
        t3,'T (K)',t16,'H2O',t29,'O2',t42,'H2',t55,'H',t68,'O',t81,'OH')
      open(20,file='saida7.dat',form='formatted')
      do p=1,n
        write(19,12) t(p),(mi(i,p),i=1,6)
        write(20,12) t(p),(mi(i,p),i=1,6)
      end do
      close(20)

      write(19,27)
   27 format(///,20x,'CONDUTIVIDADE TRMICA (W/m.K)',//, &
        t3,'T (K)',t16,'H2O',t29,'O2',t42,'H2',t55,'H',t68,'O',t81,'OH')
      open(20,file='saida8.dat',form='formatted')
      do p=1,n
        write(19,12) t(p),(k(i,p),i=1,6)
        write(20,12) t(p),(k(i,p),i=1,6)
      end do
      close(20)

      close(19)
	
      end subroutine escreverot


end module escreve